import java.net.*;
import java.sql.*;

class TratadorDePedido extends Thread
{
    private Socket CanalDeComunicacao;

    public TratadorDePedido (Socket CC)
    {
        this.CanalDeComunicacao = CC;
    }

    public void run ()
    {
        try
        {
            Class.forName ("sun.jdbc.odbc.JdbcOdbcDriver");

            Connection Conexao = DriverManager.getConnection
                                 ("jdbc:odbc:PASSAGENS","PASSAGEIRO","VIAGEM");

            Statement  Comando = Conexao.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,
                                                         ResultSet.CONCUR_READ_ONLY);
            ResultSet  Resultado;

            BufferedReader  Entrada   = new BufferedReader (
                                        new InputStreamReader (
                                        this.CanalDecomunicacao.
                                        getInputStream()));

            StringTokenizer Separador = new StringTokenizer (
                                        Entrada.readLine ());


            String Resposta;

            switch (Separador.nextToken().charAt(0))
            {
                case 'C': String DP = Separador.nextToken (),
                                 LP = Separador.nextToken (),
                                 LC = Separador.nextToken ();

                          Resultado = Comando.executeQuery (
                                      "Select Nro, HorPar, HorChg, QtdTotLugs, QtdOcpLugs " +
                                      "from Voos " +
                                      "where DatPrt = '" + DP + "' and " +
                                      "      LocPrt = '" + LP + "' and " +
                                      "      LocChg = '" + LC + "'");

                          Resultado.first();

                          Resposta = "";

                          while (!Resultado.isAfterLast())
                          {
                              int    NV =    Resultado.getInt    ("Voo");
                              String HP =    Resultado.getString ("HorPrt"),
                                     HC =    Resultado.getString ("HorChg"),
                              int    QT =    Resultado.getInt    ("QtdTotLugs"),
                                     QD = QT-Resultado.getInt    ("QtdOcpLugs");

                              Resposta = Resposta +
                                         NV + " " + HP + " " + HC + " " + QT + " " + QD + "\n";

                              Resultado.next ();
                          }
                          break;
                          
                case 'R': String NV = Separador.nextToken (),
                                 NP = Separador.nextToken ();

                          Resultado = Comando.executeQuery (
                                      "Select QtdTotLugs, QtdOcpLugs " +
                                      "from Voos " +
                                      "where Nro = " + NV);

                          Resultado.first ();

                          int QT = Resultado.getInt ("QtdTotLugs"),
                              QO = Resultado.getInt ("QtdOcpLugs");

                          if (QT == QO)
                          {
                              Resposta = "ERR";
                              break;
                          }

                          Comando.executeUpdate ("Insert into Reservas (NroVoo, NomPas) " +
                                                 "values (" + NV + ", '" + NP + "')");

                          Comando.executeUpdate ("Update Voos " +
                                                 "set QtdOcpLugs = " + (QO+1) + " " +
                                                 "where Nro = " + NV);

                          Resposta = "SUC";
                          break;

                case 'D': String NR = Separador.nextToken ();

                          Resultado = Comando.executeQuery (
                                      "Select NroVoo " +
                                      "from Reservas " +
                                      "where Nro = " + NR);

                          Resultado.first ();

                          int NV = Resultado.getInt ("NroVoo");

                          Comando.executeUpdate ("Delete from Reservas " +
                                                 "where Nro = " + NR");

                          Resultado = Comando.executeQuery (
                                      "Select QtdOcpLugs " +
                                      "from Voos " +
                                      "where Nro = " + NV);

                          Resultado.first ();

                          int QO = Resultado.getInt ("QtdOcpLugs");

                          Comando.executeUpdate ("Update Voos " +
                                                 "set QtdOcpLugs = " + (QO-1) + " " +
                                                 "where Nro = " + NV);

                          Resposta = "SUC";
                          break;
            }
        }
        catch (Exception E)
        {
            Resposta = "ERR";
        }

        PrintWriter Saida = new PrintWriter (
                            new OutputStreamWriter (
                            this.CanalDeComunicacao.getOutputStream()));

        Saida.print (Resposta);
        Saida.flush ();

        Entrada           .close ();
        Saida             .close ();
        CanalDeComunicacao.close ();
    }
}